searchData={"items":[{"type":"module","title":"LiveKit","doc":"LiveKit server SDK for Elixir.\n\nThis SDK enables you to manage LiveKit rooms and access tokens programmatically.","ref":"LiveKit.html"},{"type":"function","title":"LiveKit.hello/0","doc":"Hello world.","ref":"LiveKit.html#hello/0"},{"type":"function","title":"Examples - LiveKit.hello/0","doc":"iex> LiveKit.hello()\n    :world","ref":"LiveKit.html#hello/0-examples"},{"type":"function","title":"LiveKit.version/0","doc":"Returns the current version of the LiveKit SDK.","ref":"LiveKit.html#version/0"},{"type":"module","title":"LiveKit.AccessToken","doc":"Handles generation and management of LiveKit access tokens.","ref":"LiveKit.AccessToken.html"},{"type":"function","title":"LiveKit.AccessToken.add_grant/2","doc":"Adds a grant to the token.","ref":"LiveKit.AccessToken.html#add_grant/2"},{"type":"function","title":"LiveKit.AccessToken.new/2","doc":"Creates a new AccessToken with the given API key and secret.","ref":"LiveKit.AccessToken.html#new/2"},{"type":"type","title":"LiveKit.AccessToken.t/0","doc":"","ref":"LiveKit.AccessToken.html#t:t/0"},{"type":"function","title":"LiveKit.AccessToken.to_jwt/1","doc":"Generates a JWT token string.","ref":"LiveKit.AccessToken.html#to_jwt/1"},{"type":"function","title":"LiveKit.AccessToken.with_grants/2","doc":"Sets the grants for the token.","ref":"LiveKit.AccessToken.html#with_grants/2"},{"type":"function","title":"LiveKit.AccessToken.with_identity/2","doc":"Sets the identity for the token.","ref":"LiveKit.AccessToken.html#with_identity/2"},{"type":"function","title":"LiveKit.AccessToken.with_metadata/2","doc":"Sets metadata for the token.","ref":"LiveKit.AccessToken.html#with_metadata/2"},{"type":"function","title":"LiveKit.AccessToken.with_ttl/2","doc":"Sets the TTL (time to live) for the token in seconds.","ref":"LiveKit.AccessToken.html#with_ttl/2"},{"type":"module","title":"LiveKit.Config","doc":"Configuration module for LiveKit.\nHandles configuration management and provides a unified interface for accessing LiveKit settings.","ref":"LiveKit.Config.html"},{"type":"function","title":"LiveKit.Config.get/1","doc":"Returns the current configuration. It merges the following in order of precedence:\n1. Runtime-provided options (highest priority)\n2. Application environment\n3. Environment variables\n4. Default values (lowest priority)","ref":"LiveKit.Config.html#get/1"},{"type":"function","title":"LiveKit.Config.get_validated/1","doc":"Returns a validated configuration or an error.","ref":"LiveKit.Config.html#get_validated/1"},{"type":"type","title":"LiveKit.Config.t/0","doc":"","ref":"LiveKit.Config.html#t:t/0"},{"type":"function","title":"LiveKit.Config.validate/1","doc":"Validates the configuration and returns :ok if valid, {:error, reason} otherwise.","ref":"LiveKit.Config.html#validate/1"},{"type":"module","title":"LiveKit.EgressServiceClient","doc":"Client for interacting with the LiveKit Egress service.","ref":"LiveKit.EgressServiceClient.html"},{"type":"function","title":"LiveKit.EgressServiceClient.list_egress/2","doc":"Lists all egress operations.","ref":"LiveKit.EgressServiceClient.html#list_egress/2"},{"type":"function","title":"LiveKit.EgressServiceClient.new/3","doc":"Creates a new EgressServiceClient.","ref":"LiveKit.EgressServiceClient.html#new/3"},{"type":"function","title":"LiveKit.EgressServiceClient.start_room_composite_egress/2","doc":"Starts a room composite egress.","ref":"LiveKit.EgressServiceClient.html#start_room_composite_egress/2"},{"type":"function","title":"LiveKit.EgressServiceClient.start_track_egress/2","doc":"Starts a track egress.","ref":"LiveKit.EgressServiceClient.html#start_track_egress/2"},{"type":"function","title":"LiveKit.EgressServiceClient.stop_egress/2","doc":"Stops an egress operation.","ref":"LiveKit.EgressServiceClient.html#stop_egress/2"},{"type":"module","title":"LiveKit.Grants","doc":"Defines the structure and types for LiveKit access token grants.","ref":"LiveKit.Grants.html"},{"type":"function","title":"LiveKit.Grants.ingress_admin/0","doc":"Creates a new grant for ingress administration.","ref":"LiveKit.Grants.html#ingress_admin/0"},{"type":"function","title":"LiveKit.Grants.join_room/3","doc":"Creates a new grant for joining a room.","ref":"LiveKit.Grants.html#join_room/3"},{"type":"function","title":"LiveKit.Grants.room_admin/0","doc":"Creates a new grant for room administration.","ref":"LiveKit.Grants.html#room_admin/0"},{"type":"function","title":"LiveKit.Grants.room_create/0","doc":"Creates a new grant for room creation.","ref":"LiveKit.Grants.html#room_create/0"},{"type":"function","title":"LiveKit.Grants.room_record/0","doc":"Creates a new grant for room recording.","ref":"LiveKit.Grants.html#room_record/0"},{"type":"type","title":"LiveKit.Grants.t/0","doc":"","ref":"LiveKit.Grants.html#t:t/0"},{"type":"module","title":"LiveKit.RoomServiceClient","doc":"Client for the LiveKit Room Service API.","ref":"LiveKit.RoomServiceClient.html"},{"type":"function","title":"LiveKit.RoomServiceClient.create_room/3","doc":"Creates a new room.","ref":"LiveKit.RoomServiceClient.html#create_room/3"},{"type":"function","title":"LiveKit.RoomServiceClient.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"LiveKit.RoomServiceClient.html#delete/3"},{"type":"function","title":"LiveKit.RoomServiceClient.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"LiveKit.RoomServiceClient.html#delete!/3"},{"type":"function","title":"LiveKit.RoomServiceClient.delete_room/2","doc":"Deletes a room.","ref":"LiveKit.RoomServiceClient.html#delete_room/2"},{"type":"function","title":"LiveKit.RoomServiceClient.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"LiveKit.RoomServiceClient.html#get/3"},{"type":"function","title":"LiveKit.RoomServiceClient.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"LiveKit.RoomServiceClient.html#get!/3"},{"type":"function","title":"LiveKit.RoomServiceClient.get_participant/3","doc":"Gets a participant from a room.","ref":"LiveKit.RoomServiceClient.html#get_participant/3"},{"type":"function","title":"LiveKit.RoomServiceClient.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"LiveKit.RoomServiceClient.html#head/3"},{"type":"function","title":"LiveKit.RoomServiceClient.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"LiveKit.RoomServiceClient.html#head!/3"},{"type":"function","title":"LiveKit.RoomServiceClient.list_participants/2","doc":"Lists participants in a room.","ref":"LiveKit.RoomServiceClient.html#list_participants/2"},{"type":"function","title":"LiveKit.RoomServiceClient.list_rooms/2","doc":"Lists all rooms.","ref":"LiveKit.RoomServiceClient.html#list_rooms/2"},{"type":"function","title":"LiveKit.RoomServiceClient.mute_published_track/5","doc":"Mutes or unmutes a participant's track.","ref":"LiveKit.RoomServiceClient.html#mute_published_track/5"},{"type":"function","title":"LiveKit.RoomServiceClient.new/3","doc":"Creates a new RoomServiceClient instance.","ref":"LiveKit.RoomServiceClient.html#new/3"},{"type":"type","title":"LiveKit.RoomServiceClient.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"LiveKit.RoomServiceClient.html#t:option/0"},{"type":"function","title":"LiveKit.RoomServiceClient.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"LiveKit.RoomServiceClient.html#options/3"},{"type":"function","title":"LiveKit.RoomServiceClient.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"LiveKit.RoomServiceClient.html#options!/3"},{"type":"function","title":"LiveKit.RoomServiceClient.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"LiveKit.RoomServiceClient.html#patch/4"},{"type":"function","title":"LiveKit.RoomServiceClient.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"LiveKit.RoomServiceClient.html#patch!/4"},{"type":"function","title":"LiveKit.RoomServiceClient.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"LiveKit.RoomServiceClient.html#post/4"},{"type":"function","title":"LiveKit.RoomServiceClient.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"LiveKit.RoomServiceClient.html#post!/4"},{"type":"function","title":"LiveKit.RoomServiceClient.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"LiveKit.RoomServiceClient.html#put/4"},{"type":"function","title":"LiveKit.RoomServiceClient.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"LiveKit.RoomServiceClient.html#put!/4"},{"type":"function","title":"LiveKit.RoomServiceClient.remove_participant/3","doc":"Removes a participant from a room.","ref":"LiveKit.RoomServiceClient.html#remove_participant/3"},{"type":"function","title":"LiveKit.RoomServiceClient.request/2","doc":"Perform a request.","ref":"LiveKit.RoomServiceClient.html#request/2"},{"type":"function","title":"Options - LiveKit.RoomServiceClient.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyword list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"LiveKit.RoomServiceClient.html#request/2-options"},{"type":"function","title":"Examples - LiveKit.RoomServiceClient.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"LiveKit.RoomServiceClient.html#request/2-examples"},{"type":"function","title":"LiveKit.RoomServiceClient.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"LiveKit.RoomServiceClient.html#request!/2"},{"type":"function","title":"LiveKit.RoomServiceClient.send_data/5","doc":"Sends data to specific participants in a room.","ref":"LiveKit.RoomServiceClient.html#send_data/5"},{"type":"function","title":"LiveKit.RoomServiceClient.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"LiveKit.RoomServiceClient.html#trace/3"},{"type":"function","title":"LiveKit.RoomServiceClient.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"LiveKit.RoomServiceClient.html#trace!/3"},{"type":"function","title":"LiveKit.RoomServiceClient.update_participant/4","doc":"Updates a participant's metadata, permissions, or name.","ref":"LiveKit.RoomServiceClient.html#update_participant/4"},{"type":"function","title":"LiveKit.RoomServiceClient.update_room_metadata/3","doc":"Updates room metadata.","ref":"LiveKit.RoomServiceClient.html#update_room_metadata/3"},{"type":"function","title":"LiveKit.RoomServiceClient.update_subscriptions/5","doc":"Updates track subscriptions for a participant.","ref":"LiveKit.RoomServiceClient.html#update_subscriptions/5"},{"type":"module","title":"LiveKit.TestFormatter","doc":"Custom formatter for test environment that properly handles binary data in logs.","ref":"LiveKit.TestFormatter.html"},{"type":"function","title":"LiveKit.TestFormatter.format/4","doc":"","ref":"LiveKit.TestFormatter.html#format/4"},{"type":"module","title":"LiveKit.TokenVerifier","doc":"Verifies LiveKit access tokens.","ref":"LiveKit.TokenVerifier.html"},{"type":"function","title":"LiveKit.TokenVerifier.verify/2","doc":"Verifies a JWT token with the given API secret.","ref":"LiveKit.TokenVerifier.html#verify/2"},{"type":"function","title":"LiveKit.TokenVerifier.verify!/2","doc":"Verifies a JWT token and returns the claims if valid, raises an error otherwise.","ref":"LiveKit.TokenVerifier.html#verify!/2"},{"type":"module","title":"LiveKit.Utils","doc":"Utility functions for LiveKit SDK.","ref":"LiveKit.Utils.html"},{"type":"function","title":"LiveKit.Utils.random_string/1","doc":"Generates a random string of specified length.","ref":"LiveKit.Utils.html#random_string/1"},{"type":"function","title":"LiveKit.Utils.to_http_url/1","doc":"Converts a URL to an HTTP URL if it's not already.","ref":"LiveKit.Utils.html#to_http_url/1"},{"type":"task","title":"mix compile.proto","doc":"Mix task for compiling protobuf definitions.\nThis task is automatically run when the project is compiled.","ref":"Mix.Tasks.Compile.Proto.html"},{"type":"function","title":"Mix.Tasks.Compile.Proto.clean/0","doc":"Cleans up any generated files.","ref":"Mix.Tasks.Compile.Proto.html#clean/0"},{"type":"function","title":"Mix.Tasks.Compile.Proto.manifests/0","doc":"Returns paths to the compiled protobuf files.","ref":"Mix.Tasks.Compile.Proto.html#manifests/0"},{"type":"function","title":"Mix.Tasks.Compile.Proto.run/1","doc":"Compiles protobuf files.\nReturns `{:ok, []}` if successful, or `{:error, message}` if there was an error.","ref":"Mix.Tasks.Compile.Proto.html#run/1"},{"type":"task","title":"mix livekit","doc":"Provides CLI commands for LiveKit operations.","ref":"Mix.Tasks.Livekit.html"},{"type":"task","title":"Commands - mix livekit","doc":"Room Management:\n* `create-token` - Create an access token for room access\n* `list-rooms` - List all rooms\n* `create-room` - Create a new room\n* `delete-room` - Delete a room\n* `list-participants` - List participants in a room\n* `remove-participant` - Remove a participant from a room\n\nRecording and Streaming:\n* `start-room-recording` - Start recording a room\n* `start-track-recording` - Start recording specific tracks\n* `start-room-streaming` - Start streaming a room to RTMP endpoints\n* `start-track-stream` - Start streaming specific tracks to RTMP endpoints\n* `list-egress` - List active egress operations\n* `stop-egress` - Stop an egress operation\n\nRoom Agents:\n* `add-agent` - Add an agent to a room\n* `remove-agent` - Remove an agent from a room\n* `list-agents` - List agents in a room","ref":"Mix.Tasks.Livekit.html#module-commands"},{"type":"task","title":"Options - mix livekit","doc":"Common Options:\n* `--api-key` (`-k`) - LiveKit API key (required)\n* `--api-secret` (`-s`) - LiveKit API secret (required)\n* `--url` (`-u`) - LiveKit server URL (required for most commands)\n* `--room` (`-r`) - Room name\n* `--identity` (`-i`) - Participant identity\n* `--name` (`-n`) - Name for new room or agent\n* `--valid-for` (`-t`) - Token validity duration (e.g., \"24h\", \"30m\")\n\nRecording and Streaming Options:\n* `--output` (`-o`) - Output path (local file or s3://bucket/path)\n* `--rtmp` - RTMP streaming URL\n* `--width` - Video width (default: 1280)\n* `--height` - Video height (default: 720)\n* `--fps` - Frames per second (default: 30)\n* `--audio-bitrate` - Audio bitrate in bps (default: 128000)\n* `--video-bitrate` - Video bitrate in bps (default: 3000000)\n* `--track-id` - Track ID for track-specific operations\n* `--egress-id` - Egress ID for stopping operations\n\nAgent Options:\n* `--prompt` - Initial prompt for the agent (required for add-agent)\n* `--name` - Agent name (required for add/remove agent)","ref":"Mix.Tasks.Livekit.html#module-options"},{"type":"task","title":"Examples - mix livekit","doc":"# Create a token\n    mix livekit create-token --api-key devkey --api-secret secret --join --room my-room --identity user1 --valid-for 24h\n\n    # List rooms\n    mix livekit list-rooms --api-key devkey --api-secret secret --url https://my.livekit.server\n\n    # Create a room\n    mix livekit create-room --api-key devkey --api-secret secret --url https://my.livekit.server --name my-room\n\n    # Delete a room\n    mix livekit delete-room --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room\n\n    # List participants\n    mix livekit list-participants --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room\n\n    # Remove a participant\n    mix livekit remove-participant --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room --identity user1\n\n    # Start room recording\n    mix livekit start-room-recording --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room --output s3://bucket/recording.mp4\n\n    # Start room streaming\n    mix livekit start-room-streaming --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room --rtmp rtmp://stream.url/live\n\n    # Add an agent to a room\n    mix livekit add-agent --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room --name assistant --prompt \"You are a helpful assistant\"","ref":"Mix.Tasks.Livekit.html#module-examples"},{"type":"function","title":"Mix.Tasks.Livekit.handle_create_token/1","doc":"","ref":"Mix.Tasks.Livekit.html#handle_create_token/1"},{"type":"function","title":"Mix.Tasks.Livekit.handle_list_participants/1","doc":"","ref":"Mix.Tasks.Livekit.html#handle_list_participants/1"},{"type":"function","title":"Mix.Tasks.Livekit.handle_start_room_recording/1","doc":"","ref":"Mix.Tasks.Livekit.html#handle_start_room_recording/1"},{"type":"extras","title":"LiveKit Server SDK for Elixir","doc":"# LiveKit Server SDK for Elixir\n\nThis is *not* official Elixir server SDK for [LiveKit](https://livekit.io). This SDK allows you to manage rooms and create access tokens from your Elixir backend.","ref":"readme.html"},{"type":"extras","title":"Installation - LiveKit Server SDK for Elixir","doc":"Add `livekit` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:livekit, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - LiveKit Server SDK for Elixir","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Command Line Interface (CLI) - LiveKit Server SDK for Elixir","doc":"The SDK includes a CLI for common LiveKit operations. Here are all available commands grouped by category:\n\n#### Room Management\n```bash\n# Create an access token for room access\nmix livekit create-token --api-key devkey --api-secret secret --join --room my-room --identity user1 --valid-for 24h\n\n# List all rooms\nmix livekit list-rooms --api-key devkey --api-secret secret --url https://my.livekit.server\n\n# Create a new room\nmix livekit create-room --api-key devkey --api-secret secret --url https://my.livekit.server --name my-room\n\n# Delete a room\nmix livekit delete-room --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room\n\n# List participants in a room\nmix livekit list-participants --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room\n\n# Remove a participant from a room\nmix livekit remove-participant --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room --identity user1\n```\n\n#### Recording and Streaming\n```bash\n# Start recording a room\nmix livekit start-room-recording --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room --output s3://bucket/recording.mp4\n\n# Start recording specific tracks\nmix livekit start-track-recording --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room --track-id TR_1234 --output recordings/track.mp4\n\n# Start streaming a room to RTMP endpoints\nmix livekit start-room-streaming --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room --rtmp rtmp://stream.url/live\n\n# Start streaming specific tracks to RTMP endpoints\nmix livekit start-track-stream --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room --track-id TR_1234 --rtmp rtmp://stream.url/live\n\n# List active egress operations\nmix livekit list-egress --api-key devkey --api-secret secret --url https://my.livekit.server\n\n# Stop an egress operation\nmix livekit stop-egress --api-key devkey --api-secret secret --url https://my.livekit.server --egress-id EG_1234\n```\n\n#### Room Agents\n```bash\n# Add an agent to a room\nmix livekit add-agent --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room --name assistant --prompt \"You are a helpful assistant\"\n\n# Remove an agent from a room\nmix livekit remove-agent --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room --name assistant\n\n# List agents in a room\nmix livekit list-agents --api-key devkey --api-secret secret --url https://my.livekit.server --room my-room\n```","ref":"readme.html#command-line-interface-cli"},{"type":"extras","title":"Command Options - LiveKit Server SDK for Elixir","doc":"#### Common Options\n- `--api-key` (`-k`): LiveKit API key (required)\n- `--api-secret` (`-s`): LiveKit API secret (required)\n- `--url` (`-u`): LiveKit server URL (required for most commands)\n- `--room` (`-r`): Room name\n- `--identity` (`-i`): Participant identity\n- `--name` (`-n`): Name for new room or agent\n- `--valid-for` (`-t`): Token validity duration (e.g., \"24h\", \"30m\")\n\n#### Recording and Streaming Options\n- `--output` (`-o`): Output path (local file or s3://bucket/path)\n- `--rtmp`: RTMP streaming URL\n- `--width`: Video width (default: 1280)\n- `--height`: Video height (default: 720)\n- `--fps`: Frames per second (default: 30)\n- `--audio-bitrate`: Audio bitrate in bps (default: 128000)\n- `--video-bitrate`: Video bitrate in bps (default: 3000000)\n- `--track-id`: Track ID for track-specific operations\n- `--egress-id`: Egress ID for stopping operations\n\n#### Agent Options\n- `--prompt`: Initial prompt for the agent (required for add-agent)\n- `--name`: Agent name (required for add/remove agent)\n\nFor more detailed information about available commands and options:\n```bash\nmix help livekit\n```","ref":"readme.html#command-options"},{"type":"extras","title":"Creating Access Tokens - LiveKit Server SDK for Elixir","doc":"```elixir\nalias LiveKit.AccessToken\nalias LiveKit.Grants\n\n# Create a new access token\ntoken = AccessToken.new(\"api-key\", \"api-secret\")\n  |> AccessToken.with_identity(\"user-id\")\n  |> AccessToken.with_ttl(3600) # 1 hour\n  |> AccessToken.add_grant(Grants.join_room(\"room-name\"))\n\n# Convert to JWT\njwt = AccessToken.to_jwt(token)\n```","ref":"readme.html#creating-access-tokens"},{"type":"extras","title":"Managing Rooms - LiveKit Server SDK for Elixir","doc":"```elixir\nalias LiveKit.RoomServiceClient\n\n# Create a client\nclient = RoomServiceClient.new(\"https://your-livekit-host\", \"api-key\", \"api-secret\")\n\n# Create a room\n{:ok, room} = RoomServiceClient.create_room(client, \"room-name\", empty_timeout: 300)\n\n# List rooms\n{:ok, rooms} = RoomServiceClient.list_rooms(client)\n\n# Delete a room\n{:ok, _} = RoomServiceClient.delete_room(client, \"room-name\")\n\n# List participants in a room\n{:ok, participants} = RoomServiceClient.list_participants(client, \"room-name\")\n\n# Remove a participant from a room\n{:ok, _} = RoomServiceClient.remove_participant(client, \"room-name\", \"participant-identity\")\n```","ref":"readme.html#managing-rooms"},{"type":"extras","title":"Verifying Tokens - LiveKit Server SDK for Elixir","doc":"```elixir\nalias LiveKit.TokenVerifier\n\n# Verify a token\ncase TokenVerifier.verify(jwt, \"api-secret\") do\n  {:ok, claims} ->\n    # Token is valid, claims contains the decoded data\n    IO.inspect(claims)\n  {:error, reason} ->\n    # Token is invalid\n    IO.puts(\"Invalid token: #{inspect(reason)}\")\nend\n```","ref":"readme.html#verifying-tokens"},{"type":"extras","title":"Room Egress - LiveKit Server SDK for Elixir","doc":"```elixir\n# Configure automatic room recording\n{:ok, room} = RoomServiceClient.create_room(client, \"room-name\",\n  egress: %LiveKit.RoomEgress{\n    room: %LiveKit.RoomCompositeEgressRequest{\n      file: %LiveKit.EncodedFileOutput{\n        filepath: \"recordings/room-name.mp4\",\n        disable_manifest: false\n      },\n      options: %LiveKit.RoomCompositeEgressRequest.Options{\n        video_width: 1280,\n        video_height: 720,\n        fps: 30,\n        audio_bitrate: 128000,\n        video_bitrate: 3000000\n      }\n    }\n  }\n)\n```","ref":"readme.html#room-egress"},{"type":"extras","title":"Room Agents - LiveKit Server SDK for Elixir","doc":"```elixir\n# Configure room agents\n{:ok, room} = RoomServiceClient.create_room(client, \"room-name\",\n  agents: [\n    %LiveKit.RoomAgentDispatch{\n      name: \"my-agent\",\n      identity: \"agent-1\",\n      init_request: %{\n        \"prompt\" => \"You are a helpful assistant\"\n      }\n    }\n  ]\n)\n```","ref":"readme.html#room-agents"},{"type":"extras","title":"Configuration - LiveKit Server SDK for Elixir","doc":"The SDK supports multiple ways to configure LiveKit credentials and settings:","ref":"readme.html#configuration"},{"type":"extras","title":"Environment Variables - LiveKit Server SDK for Elixir","doc":"You can set your LiveKit configuration using environment variables:\n\n```bash\nexport LIVEKIT_URL=\"wss://your-livekit-server.com\"\nexport LIVEKIT_API_KEY=\"your-api-key\"\nexport LIVEKIT_API_SECRET=\"your-api-secret\"\n```","ref":"readme.html#environment-variables"},{"type":"extras","title":"Application Configuration - LiveKit Server SDK for Elixir","doc":"Add LiveKit configuration to your `config/config.exs` or environment-specific config file:\n\n```elixir\nconfig :livekit,\n  url: \"wss://your-livekit-server.com\",\n  api_key: \"your-api-key\",\n  api_secret: \"your-api-secret\"\n```","ref":"readme.html#application-configuration"},{"type":"extras","title":"Runtime Configuration - LiveKit Server SDK for Elixir","doc":"You can override configuration at runtime by passing options to functions:\n\n```elixir\nopts = [\n  url: \"wss://different-server.com\",\n  api_key: \"different-key\",\n  api_secret: \"different-secret\"\n]\n\n# These options will override any environment or application config\nmix livekit create-token --room my-room --identity user1 --valid-for 24h\n```\n\nThe configuration system follows this priority order:\n1. Runtime options (highest priority)\n2. Environment variables\n3. Application configuration\n4. Default values (lowest priority)","ref":"readme.html#runtime-configuration"},{"type":"extras","title":"Development - LiveKit Server SDK for Elixir","doc":"#### Protobuf Compilation\n\nThe SDK includes a Mix task for compiling protobuf definitions:\n\n```bash\nmix compile.proto\n```\n\nThis will compile all `.proto` files in the `proto/` directory and generate Elixir modules in `lib/livekit/proto/`.","ref":"readme.html#development"},{"type":"extras","title":"License - LiveKit Server SDK for Elixir","doc":"Apache License 2.0","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.1"}}